package cks.model;

public class LocatableException extends Exception
{
  public LocatableException(String message)
  {
    super(message);
  }

  public LocatableException(Location loc, String message)
  {
    super(createMessage(loc, message));
  }

  public LocatableException(Location loc, String message, Location loc2)
  {
    super(createMessage(loc, message, null, loc2));
  }

  public LocatableException(Location loc, String message, String message2, Location loc2)
  {
    super(createMessage(loc, message, message2, loc2));
		assert message2 != null;
  }

  private static String createMessage(Location loc, String message)
  {
		assert loc != null;

    StringBuilder builder = new StringBuilder();
    loc.toString(builder);
    builder.append(": ");
    builder.append(message);
    return builder.toString();
  }

  private static String createMessage(Location loc, String message, String message2, Location loc2)
  {
    assert loc != null;

    StringBuilder builder = new StringBuilder();
    if (loc != null) {
      loc.toString(builder);
      builder.append(": ");
    }
    builder.append(message);

		// Secondary message and location
		if (loc2 != null) {
			if (message2 != null) {
				builder.append("; ");
				builder.append(message2);
			}
			if (loc2 != null) {
				builder.append(" [");
				loc2.toStringRelative(builder, loc);
				builder.append("]");
			}
		}

    return builder.toString();
  }

}

