package cks.model.value;

import cks.model.*;

import java.io.PrintWriter;
import java.util.List;
import java.util.Map;

public class VRecord extends Value
{
	public final Map<String,VField> fields;

	public VRecord(Location loc, Map<String,VField> fields)
	{
		super(loc);
		this.fields = fields;
	}

	protected void dumpChildren(PrintWriter out, int depth)
	{
		for (VField field : fields.values()) {
			indent(out, depth);
			out.println(field.name);
			field.value.dump(out, depth+1);
		}

		super.dumpChildren(out, depth);
	}
}
